/*
 * NewRegist.java
 *
 * DATE : 2009/08/02 12:28
 */
import com.nttdocomo.ui.Panel;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.KeyListener;
import com.nttdocomo.ui.SoftKeyListener;


import com.nttdocomo.ui.*;

import java.util.Vector;
import java.lang.String;

/**
 * NewRegist
 *
 * @author NAME
 */
public class RegistPanel extends Panel implements SoftKeyListener, KeyListener, ComponentListener
{
	private Panel prevPanel;
	private Panel selPanel;
	Label	lblLabel;
	/*
	ListBox List;
	*/
	
	private Label[][]	areaLbl = new Label[17][4];
	private Button[]	areaBtn = new Button[17];
	private Button	saveBtn;
	private Label	monsLbl;
	private Button	monsBtn;
	private ListBox lstLv;
	
	ListBox lstPre;
	ListBox lstSuf;
	ListBox lstBos;
	ListBox lstSpa;
	ListBox lstEx;
	ListBox lstPoi;
	
	SuperDataArea dpre = new DataAreaPrefix();
	SuperDataArea dsuf = new DataAreaSuffix();
	SuperDataArea dbos = new DataAreaBoss();
	SuperDataArea dspa = new DataAreaSpace();
	SuperDataAreaMaps dexs = new DataAreaExs();
	SuperDataArea dpoi = new DataAreaPoint();
	
	
	DataAll dataAll = null;
	
    RegistPanel(Panel prevPanel, DataAll setDataAll) {
    	int i;
    	
    	this.prevPanel = prevPanel;
    	
        setTitle("Regist");
        
        // VK쐬EҏW̔f
        if ( setDataAll == null ) {
        	dataAll = new DataAll();
        } else {
        	dataAll = setDataAll;
        }
        
		lstLv = new ListBox(ListBox.CHOICE);
		for ( i = 1; i < 100; i++ ) {
			lstLv.append(i+"");
		}
		Font f = Font.getFont(Font.FACE_SYSTEM|Font.STYLE_PLAIN|Font.SIZE_TINY);
		lstLv.setSize( 25 + f.stringWidth("99"), lstLv.getHeight());
		lstLv.setFont( f );
		
		lstPre = dpre.GetList();
		lstSuf = dsuf.GetList();
		lstEx  = dexs.GetNameList("");
		lstSpa = dspa.GetList();
		lstBos = dbos.GetList();
		lstPoi = dpoi.GetList();
		
		lstPre.select( dataAll.areaPrefix 	 );
		lstSuf.select( dataAll.areaSuffix 	 );
		lstEx.select(  dataAll.areaEx 		 );
		lstSpa.select( dataAll.areaSpace 	 );
		lstLv.select(  dataAll.areaLv 		 );
		lstBos.select( dataAll.areaBoss 	 );
		lstPoi.select( dataAll.areaPoint 	 );

        saveBtn = new Button("ۑ");
		monsBtn = new Button("1F X^[");
		monsLbl = new Label("");
		
		// ---- START LAYOUT ----
        HTMLLayout layout = new HTMLLayout();
		setLayoutManager(layout);
		
        layout.begin(HTMLLayout.LEFT);
		this.add( lstPre );
		this.add( lstSuf );
		this.add( lstEx  );
        layout.br();
		this.add( lstSpa );
		this.add( lstLv );
		this.add( lstPoi );
        layout.br();

        this.add( monsBtn );
        this.add( monsLbl );
        layout.br();
        // 3F to 16F
	    for ( i = 3; i < 17; i++ ) {
	    	// Floor Button
        	areaBtn[i] = new Button();
        	if ( i < 10 ) {
	        	areaBtn[i].setLabel( " " + i + "F");
	        } else {
	        	areaBtn[i].setLabel( i + "F");
	        }
        	this.add( areaBtn[i] );
        	
        	// Item Label
	        for ( int j = 0; j < 4; j++ ) {
	        	areaLbl[i][j] = new Label("", Label.LEFT);
	        	areaLbl[i][j].setVisible(false);

	        	this.add( areaLbl[i][j] );
	        }
        	layout.br();
        }
        
		this.add( lstBos );
        layout.br();
        
        this.add( saveBtn );
        
        layout.end();
        // ---- END LAYOUT ----
		
		//\tgL[̃xɕ\ݒ
		this.setSoftLabel(Frame.SOFT_KEY_1, "ۑ");
		this.setSoftLabel(Frame.SOFT_KEY_2, "f");
		
		//L[Xi̐ݒ
		this.setSoftKeyListener((SoftKeyListener)this);
		this.setKeyListener((KeyListener)this);
		this.setComponentListener(this);
        
		// Item ̕\
        setDatas();
    }
    
    public void save() {
		DataWriter writer = new DataWriter();
		dataAll.areaPrefix 	= lstPre.getSelectedIndex();
		dataAll.areaSuffix 	= lstSuf.getSelectedIndex();
		dataAll.areaEx 		= lstEx.getSelectedIndex();
		dataAll.areaSpace 	= lstSpa.getSelectedIndex();
		dataAll.areaLv 		= lstLv.getSelectedIndex();
		dataAll.areaBoss 	= lstBos.getSelectedIndex();
		dataAll.areaPoint 	= lstPoi.getSelectedIndex();
		
		writer.write( dataAll.setCount, dataAll);
        Display.setCurrent( prevPanel );
    }
    
    public void componentAction(Component c, int type, int param)
    {
		for ( int i = 3; i < 17; i++ ) {
	    	if ( c == areaBtn[i] ) {
	    		selPanel = new SelectFloorItem(this, i, (Vector) dataAll.floors.get(i + ""));
    			Display.setCurrent(selPanel);
    			return;
	    	}
	    }
    	if ( c == saveBtn ) {
    		save();
    	} else if ( c == monsBtn ) {
    		selPanel = new SelectMonsterPanel(this, lstSpa.getItem(lstSpa.getSelectedIndex()), dataAll.monster);
			Display.setCurrent(selPanel);
		}
    }
    
    public void setDatas()
    {
    	Vector floors = null;
    	DataFloor floor = null;
    	String space;
		DataAreaFloor dflr = new DataAreaFloor();
		DataAreaItems ditms = new DataAreaItems();
		
		int i, j, k;
		Vector itemNames = new Vector();
		String itemName;
		
		if ( dataAll.floors == null ) {
			System.out.println("dataAll.floors == null");
			return;
		}
		System.out.println("dataAll.floors.size()" + dataAll.floors.size());
    	if ( dataAll.floors.size() > 0 ) {
    		for ( i = 3; i < 17; i++ ) {
	    		floors = (Vector) dataAll.floors.get(i + "");
	    		if ( floors != null ) {
	    			System.out.println("floors is not null" + floors.size());
	    			for ( j = 0; j < floors.size(); j++ ) {
	    				floor = (DataFloor) floors.elementAt(j);
	    				if ( floor.space[j][0] != 0 ) {
	    					space = dflr.GetData(floor.space[j][0]);
	    					if ( floor.space[j][1] != 0 ) {
	    						space += "" + dflr.GetData(floor.space[j][1]);
	    					}
	    					if ( floor.items == null ) {
	    						break;
	    					}
	    					itemNames.removeAllElements();
	    					for ( k = 0; k < floor.items.size(); k++ ) {
		        				itemName = ((DataAreaItem) floor.items.elementAt(k)).name;
		        				itemNames.addElement(itemName);
			        		}
			        		
			    			setData( i, j, null, space,ditms.GetRankList(itemNames));
			    		} else {
			    			break;
			    		}
		    		}
	    		}
	    	}
	    }
    }
    
    public void viewMonsData() {
    	Vector monsNames = new Vector();	// <String>
    	DataAreaMonsters dmns = new DataAreaMonsters();
    	DataAreaMonster  dmn;
    	
    	for ( int i = 0; i < dataAll.monster.monsters.length; i++) {
    		if ( dataAll.monster.monsters[i] > 0 ) {
	    		dmn = dmns.GetAreaItemFromUnique(Integer.toString(dataAll.monster.monsters[i]));
	    		monsNames.addElement(dmn.name);
    		}
    	}
    	if ( monsNames.size() > 0 ) {
    		monsLbl.setText("Rank:" + dmns.GetRankList(monsNames));
    	} else {
    		monsLbl.setText("");
    	}
    }
    
    public void setData(int floor, int num, DataFloor dataFloor, String space, String itemRank)
    {
    	Vector vecDataFloor;
    	
    	if ( dataFloor != null ) {
	    	if ( num == 0 ) {
	    		vecDataFloor = new Vector();
	    	} else {
		    	vecDataFloor = (Vector) dataAll.floors.get(floor + "");
		    	if ( vecDataFloor == null ) {
		    		vecDataFloor = new Vector();
		    	}
		    }
	    	vecDataFloor.addElement(dataFloor);
	    	dataAll.floors.put( floor + "", vecDataFloor);
    	}
    	areaLbl[floor][num].setText(space + "^Rank:" + itemRank);
    	areaLbl[floor][num].setSize(this.getWidth() - 6, areaLbl[floor][num].getHeight());
    	areaLbl[floor][num].setVisible(true);
    }
    
    public void softKeyPressed(int softKey) {
    }
    
    public void softKeyReleased(int softKey) {
        if (softKey == SOFT_KEY_1) {
            save();	// ۑ
        } else {
        	IApplication.getCurrentApp().terminate();
        }
    }
    
    public void keyPressed(Panel panel, int key) {
    }
    
    public void keyReleased(Panel panel, int key) {
        switch (key) {
            case Display.KEY_1:
                break;
            case Display.KEY_2:
                break;
            case Display.KEY_3:
                break;
            default:
                break;
        }
    }

}
